﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace library {
    [Serializable]
    public class Command {

        private String source;
        private String dest;
        private int type;
        private String data;
        private User user;
        private List<Contact> contacts;
        private Contact contact;

        public Command(int type, User user) { //registration command
            this.type = type;
            this.user = user;
            this.source = null;
            this.dest = null;
            this.data = null;
            this.contacts = null;
            this.contact = null;
        }

        public Command(int type, List<Contact> contacts) { //registration ack true
            this.type = type;
            this.contacts = contacts;
            this.user = null;
            this.source = null;
            this.dest = null;
            this.data = null;
            this.contact = null;
        }
        public Command(int type) { //common command
            this.type = type;
            this.contacts = null;
            this.user = null;
            this.source = null;
            this.dest = null;
            this.data = null;
            this.contact = null;
        }

        public Command(int type, String source, String dest, String data) { //message command
            this.source = source;
            this.dest = dest;
            this.type = type;
            this.data = data;
            this.user = null;
            this.contacts = null;
            this.contact = null;
        }
        public Command(int type, Contact contact, String dest) { //update contact list
            this.type = type;
            this.contact = contact;
            this.user = null;
            this.contacts = null;
            this.source = null;
            this.dest = dest;
            this.data = null;
        }
        public void setContact(Contact contact) {
            this.contact = contact;
        }
        public void setContacts(List<Contact> contacts) {
            this.contacts = contacts;
        }
        public Contact getContact() {
            return this.contact;
        }
        public List<Contact> getContacts() {
            return this.contacts;
        }
        public void setSource(String source) {
            this.source = source;
        }
        public void setDest(String dest) {
            this.dest = dest;
        }
        public void setType(int type) {
            this.type = type;
        }
        public void setData(String data) {
            this.data = data;
        }

        public String getSource() {
            return this.source;
        }
        public String getDest() {
            return this.dest;
        }
        public int getType() {
            return this.type;
        }
        public String getData() {
            return this.data;
        }
        public User getUser() {
            return this.user;
        }
        public void setUser(User user) {
            this.user = user;
        }
        /*
         * Command parametres:
         * 
         * Login:                   1
         * Login successful:        2        
         * Registration:            3
         * RegistrationACK-true:    4
         * Message:                 5
         * Update contact list - f: 6
         * Update contact list - t: 7
         * logout:                  8
         * Add Contact              9
         * Add Contact true         10
         * Add Contact false        104
         * Update Contact           11
         * Update Contact true      12
         * Update Contact false     105
         * Delete Contact           13
         * Delete Contact true      14
         * Delete Contact false     106
         * find user                15
         * find user true           16
         * find user false          107
         * Message-false:           103
         * RegistrationACK-false:   102 
         * Login name error:        100
         * Login password error:    101
         * 
         */

    }
}
